/*
 *	@(#) xswclient.h 12.1 95/07/07 SCOINC
 */
/***************************************************************************
 *
 *	Copyright (c) 1990-1993		The Santa Cruz Operation, Inc.
 *
 *	All rights reserved.  No part of this program or publication may be
 *	reproduced, transmitted, transcribed, stored in a retrieval system,
 *	or translated into any language or computer language, in any form or
 *	by any means, electronic, mechanical, magnetic, optical, chemical,
 *	biological, or otherwise, without the prior written permission of:
 *	
 *		The Santa Cruz Operation , Inc.		(408) 425-7222
 *		400 Encinal St., Santa Cruz, California 95060 USA
 *
 **************************************************************************/
/*
 * Modification History
 *
 *
 * S002, 21-Sep-93, rickra
 * 	 Added disk_space_struct
 *
 * S001, 27-May-93, rickra
 * 	 Added PS MEM fields.. 
 *
 * S000, 30-Sep-92, rickra
 * 	 Added copyright and modification history
 */

#include <sys/proc.h>
#include <sys/fs/s5dir.h>
#include <sys/user.h>


struct my_user_struct
{
short   	p_pid;
unsigned        u_tsize;
unsigned        u_dsize;
unsigned        u_ssize;
time_t		u_utime;
time_t		u_stime;
char            u_psargs[PSARGSZ];
char		u_comm[PSCOMSIZ];
long		u_ior;
long		u_iow;
long		u_iosw;
long		u_ioch;
};

struct my_proc_struct 
{
char	p_stat;
short	p_pid;
uint	p_flag;
preg_t	*p_region;
ushort	p_usize;
ushort	p_uid;
ushort	p_suid;
char	p_cpu;
char	p_pri;
char	p_nice;
short	p_pgrp;
char    name[10];
char		tty[3];
};

typedef struct memory_usage {
	char    name[10];
        short   p_pid;
        ushort  p_uid;
        ushort  p_suid;
        int     shared;
        int     weighted;
        int     total;
        int     virtual;
        int     private;
	int	none;
	int	swap;
	int	file;
	int	lstfile;

	int	swap_core;
	int	file_core;
	int	lstfile_core;

	int	zero;
	int	fill;
#ifndef XSW32v5
	int	iomap;
	int	window;
#else
	int proc; 
#endif

        char    u_psargs[PSARGSZ];
        } process_memory;

typedef struct memory_usage_bak {
        short   p_pid;
        ushort  total_1;
        ushort  shared;
        ushort  weighted;
        ushort  virtual;
        ushort  private;

	ushort  swap_core;
	ushort	file_core;
	ushort	lstfile_core;
        ushort  total_2;

	ushort  none;
	ushort  swap;
  	ushort  file;
	ushort  lstfile;
	ushort	zero;
	ushort	fill;
#ifndef XSW32v5
	ushort	iomap;
	ushort	window;
#else
	ushort proc; 
#endif

        } process_memory_bak;


typedef struct disk_space_struct 
{


/* 
  Indicates Broken NFS or Automount mount pt 
*/

	int	problems   ;
	int	nfs_filesystem;
/*
  mnttab.h
*/

     char     dev[BUFSIZ];
     char     dir[BUFSIZ];

     short   mt_ro_flg;
     time_t  mt_time;

/*
  statfs.h
*/

	short   f_fstyp;        /* File system type */
        long    f_bsize;        /* Block size */
        long    f_frsize;       /* Fragment size (if supported) */
        long    f_blocks;       /* Total number of blocks on file system */
        long    f_bfree;        /* Total number of free blocks */
        long    f_files;        /* Total number of file nodes (inodes) */
        long    f_ffree;        /* Total number of free file nodes */
        char    f_fname[6];     /* Volume name */
        char    f_fpack[6];     /* Pack name */

} disk_space;

